<?php
namespace Geral\Logic\Produto;

use \Geral\Entities\Paramfilial;
use Geral\Util\DateUtil;
use Geral\Util\TratamentoDeMensagens;
use Indeterminado\Entities\Relacproditgen;


class Produto{

    // Abre a tela popUP Informações Complementares do Produto - win_pbi00163_000
	public static function openInfComplProd($cdfilial, $dtlancmovi, $cdproduto, $cdalmoxarifado,
	                                        $cdlocalestoque, $nrloteestq, $nrsublote, $nrorg, $boShowLote = false,
                                            $boShowAlmox = true, $boShowEntr = false,$boAjuste = false,
                                            $boAtuEstoq = true, $boVerQtEst = true, $boDocuDevo = false, 
	                                        $boAfPiloto = false){

	    // Se a filial não Utilizar Lote, não utilizar Almoxarifado, não Utilizar Controle de Estoque ou o boAtuEstoq == false não abre a tela e só retorna os seguintes parámetros na ENV_VAR

        /* @var $paramfilial Paramfilial */
	    $paramfilial = Paramfilial::findOneByCdfilialAndNrorg($cdfilial,$nrorg);
	    if(($paramfilial->getIdutillote()  == 'N' and $paramfilial->getIdutilalmox() == 'N' and $paramfilial->getIdutillcestq() == 'N') or ($boAtuEstoq == false)){
	    
		    $dados_retorno = array('CDALMOXARIFE' => ' ',
	                               'CDLOCALESTOQ' => ' ',
	                               'NRLOTEESTQ'   => ' ',
	                               'NRSUBLOTE'    => ' ',);

	        tk_set_env_var('DADOS_RETORNO_PBI00163', $dados_retorno);
        }
        else{
		    $params[] = array(
		                      "CDFILIAL"   => $cdfilial,
		                      "DTLANCMOVI" => $dtlancmovi,
		                      "CDPRODUTO"  => $cdproduto,
		                      "CDALMOXARIFADO" => $cdalmoxarifado,
		                      "CDLOCALESTOQ" => $cdlocalestoque,
		                      "NRLOTEESTQ" => $nrloteestq,
		                      "NRSUBLOTE" => $nrsublote,	           
		                      "NRORG" => $nrorg,
		                      "BOSHOWLOTE" => $boShowLote,
		                      "BOSHOWALMOX" => $boShowAlmox,
		                      "BOSHOWENTR" => $boShowEntr,
		                      "BOAJUSTE" => $boAjuste,
		                      "BOATUESTOQ" => $boAtuEstoq,
		                      "BOVERQTEST" => $boVerQtEst,
		                      "BODOCUDEVO" => $boDocuDevo,
		                      "BOAFPILOTO" => $boAfPiloto,	          
		          	          );

		 	                                 
	        tk_set_env_var('PARAM_PBI00163',$params[0]);
	        
	        //Utilizado para controlar cancelamento dos itens na window que chamou
	        tk_set_env_var('BOCANCEL',true);
	 		tk_open_window('win_pbi00163_000',true);
 	    }
	}

    // Formata a data de forma que possa ser inserida no banco
    public static function formataData($data)
    {
        if (strlen($data) == 19)
            $data = DateUtil::truncateString($data);
        $data = DateUtil::getDataDeString($data);
        $data = DateUtil::truncateData($data);

        return $data;
    }

    public static function atualizaProdutoLivroMagnetico($livroMagnetico, $produto, $genero, $tipo, $organizacao)
    {
        /** @var Relacproditgen $relacProdLivroMag */
        $relacProdLivroMag = Relacproditgen::findOneByCdlivromagAndCdprodutoAndNrorg($livroMagnetico, $produto, $organizacao);
        if (empty($relacProdLivroMag) && !empty($genero) && !empty($tipo))
            self::insertProdutoLivroMagnetico($livroMagnetico, $produto, $genero, $tipo, $organizacao);
        elseif (!empty($relacProdLivroMag) && !empty($genero) && !empty($tipo))
            self::updateProdutoLivroMagnetico($relacProdLivroMag, $genero, $tipo, $organizacao);
        elseif (!empty($relacProdLivroMag))
            self::deleteProdutoLivroMagnetico($relacProdLivroMag);
    }

    public static function insertProdutoLivroMagnetico($livroMagnetico, $produto, $genero, $tipo, $organizacao)
    {
        try {
            $connection = \Setforms2\Shared\Registry::getEntityManager();
            $connection->beginTransaction();

            /** @var Relacproditgen $relacProdLivroMag */
            $relacProdLivroMag = new Relacproditgen();
            $relacProdLivroMag->setCdlivromag($livroMagnetico);
            $relacProdLivroMag->setCdproduto($produto);
            $relacProdLivroMag->setCdgenprod($genero);
            $relacProdLivroMag->setCdtpitemprod($tipo);
            $relacProdLivroMag->setNrorg($organizacao);
            $relacProdLivroMag->setNrorginclusao($organizacao);
            $relacProdLivroMag->setNrorgultatu($organizacao);
            $relacProdLivroMag->setDtinclusao(self::formataData(now()));
            $relacProdLivroMag->setDtultatu(self::formataData(now()));
            $relacProdLivroMag->setCdoperinclusao(\Geral\Util\Ambiente::getCdOperador());
            $relacProdLivroMag->setCdoperultatu(\Geral\Util\Ambiente::getCdOperador());
            $relacProdLivroMag->persist();

            $connection->flush();
            $connection->commit();

        } catch (\Exception $e) {
            $connection->rollback();
            TratamentoDeMensagens::exibirMensagens($e);
        }
    }

    public static function updateProdutoLivroMagnetico($relacProdLivroMag, $genero, $tipo, $organizacao)
    {
        try {
            $connection = \Setforms2\Shared\Registry::getEntityManager();
            $connection->beginTransaction();

            /** @var Relacproditgen $relacProdLivroMag */
            $relacProdLivroMag->setCdgenprod($genero);
            $relacProdLivroMag->setCdtpitemprod($tipo);
            $relacProdLivroMag->setNrorgultatu($organizacao);
            $relacProdLivroMag->setCdoperultatu(\Geral\Util\Ambiente::getCdOperador());
            $relacProdLivroMag->getDtultatu(self::formataData(now()));

            $connection->flush();
            $connection->commit();

        } catch (\Exception $e) {
            $connection->rollback();
            TratamentoDeMensagens::exibirMensagens($e);
        }
    }

    public static function deleteProdutoLivroMagnetico($relacProdLivroMag)
    {
        try {
            $connection = \Setforms2\Shared\Registry::getEntityManager();
            $connection->beginTransaction();

            /** @var Relacproditgen $relacProdLivroMag */
            $relacProdLivroMag->delete();

            $connection->flush();
            $connection->commit();

        } catch (\Exception $e) {
            $connection->rollback();
            TratamentoDeMensagens::exibirMensagens($e);
        }
    }
}