<?php

namespace Planejamento\Logic\Cardapio;

use Planejamento\Entities\Recepadr;
use Planejamento\Entities\Recefili;
use Planejamento\Entities\Receserv;
use Geral\Entities\Paramgeral;

/**
 *
 * @author paulosoares paulo.soares@teknisa.com
 *         Realiza a importacao da receita e suas validacoes
 */
class ImportacaoReceita {
	const MSG_REVISAR_RECEITA = 'msg_importacao_receita_RevisarReceita';



    public static function importacaoReceitaPadraoParaPadrao(
        $cdpratoO, $cdFilAuxPratO,
        $cdpratoD, $filAuxPratD,
        $nrorg, $dataAtual, $operador, $parametros, $updatedRows
    ) {
        $receitasPadraoO = Recepadr::getObjectsByWhere (
            "CDPRATO = ?  AND NRORG = ? AND CDFILAUXPRAT = ?",
            array (
                $cdpratoO,
                $nrorg,
                $cdFilAuxPratO
            ) );

        $receitasPadrao = Recepadr::getObjectsByWhere (
            "CDPRATO = ?  AND NRORG = ? AND CDFILAUXPRAT = ?",
            array (
                $cdpratoD,
                $nrorg,
                $filAuxPratD
            ) );

        if ($parametros === 'S') {
            self::deletaReceita ( $receitasPadrao );
        }
        if(!$updatedRows) {
            $updatedRows = array();
        }

        $connection = \SetForms2\Shared\Registry::getEntityManager ();
        $connection->beginTransaction ();
        try {
            /**
             *
             * @var $receita \Planejamento\Entities\Base\Recefili
             */
            foreach ( $receitasPadraoO as $receitaPadraoO ) {
                $existente = self::validaProdutoIgual($receitaPadraoO, $receitasPadrao, $parametros);
                if(!$existente){
                    $receitaPadrao = new Recepadr ();
                    $receitaPadrao->setQtprodprat ( $receitaPadraoO->getQtprodprat() );
                    $receitaPadrao->setSgunidade ( $receitaPadraoO->getSgunidade () );
                    $receitaPadrao->setIdqtdefixpr ( $receitaPadraoO->getIdqtdefixpr () );
                    $receitaPadrao->setVrpefatcocpr ( $receitaPadraoO->getVrpefatcocpr () );
                    $receitaPadrao->setVrpefatcorpr ( $receitaPadraoO->getVrpefatcorpr () );
                    $receitaPadrao->setHrtemppreppr ( $receitaPadraoO->getHrtemppreppr () );
                    $receitaPadrao->setQtbrutaprunr ( $receitaPadraoO->getQtbrutaprunr () );
                    $receitaPadrao->setQtbrutapr ( $receitaPadraoO->getQtbrutapr () );
                    $receitaPadrao->setIdprodbasepr ( $receitaPadraoO->getIdprodbasepr () );
                    $receitaPadrao->setVrpefatnutpr ( $receitaPadraoO->getVrpefatnutpr() );
                    $receitaPadrao->setQtcalcnutrpr ( $receitaPadraoO->getQtcalcnutrpr() );
                    $receitaPadrao->setIdativo ( $receitaPadraoO->getIdativo () );
                    $receitaPadrao->setNrorg ( $receitaPadraoO->getNrorg () );
                    $receitaPadrao->setCdfilauxprat($filAuxPratD);
                    $receitaPadrao->setCdproduto ( $receitaPadraoO->getCdproduto () );
                    $receitaPadrao->setIdutcompentdirp ( $receitaPadraoO->getIdutcompentdirp() );
                    $receitaPadrao->setCdprato ( $cdpratoD );
                    $receitaPadrao->setDtinclusao ( $dataAtual );
                    $receitaPadrao->setDtultatu ( $dataAtual );
                    $receitaPadrao->setCdoperinclusao ( $operador );
                    $receitaPadrao->setCdoperultatu ( $operador );
                    foreach ( $updatedRows as $row ) {
                        if ($receitaPadrao->getCdproduto () == $row ['CODPRODUTO']) {
                            $receitaPadrao->setQtprodprat ( $row ['QTDLIQUIDA'] );
                            $receitaPadrao->setSgunidade ( $row ['SGUNIDADE'] );
                            $receitaPadrao->setIdqtdefixpr ( $row ['QTDFIXA'] );
                            $receitaPadrao->setVrpefatcocpr ( $row ['GANHOCOCCAO'] );
                            $receitaPadrao->setVrpefatcorpr ( $row ['PERDALIMP'] );
                            $receitaPadrao->setHrtemppreppr ( $row ['TEMPOPREP'] );
                            $receitaPadrao->setQtbrutaprunr ( $row ['QTDBRUTA'] );
                            $receitaPadrao->setQtbrutapr ( $row ['QTDEREQUERIDA'] );
                            $receitaPadrao->setIdprodbasepr ( $row ['PRBASE'] );
                            $receitaPadrao->setVrpefatnutpr ( $row ['APROVNUTRI'] );
                            $receitaPadrao->setQtcalcnutrpr ( $row ['QTDECALCULONUTRI'] );
                            continue 1;
                        }
                    }
                    $receitaPadrao->persist ();
                    $connection->flush ();
                }
            }

            $connection->commit ();
            return true;
        } catch ( \Exception $e ) {
            tk_warning ( $e->getMessage () );
            $connection->rollback ();
            return false;
        }
    }

	public static function importacaoReceitaLocalParaPadrao(
        $cdpratoO, $cdFilialO, $cdFilAuxPratO,
        $cdpratoD, $filAuxPratD,
        $nrorg, $dataAtual, $operador, $parametros, $updatedRows
    ) {
        /**
         *
         * @var $receitas \Planejamento\Entities\Base\Recefili
         */
        $receitasLocal = Recefili::getObjectsByWhere (
            "NRORG = ? AND CDFILIAL = ? AND CDPRATO = ? AND CDFILAUXPRAT = ?",
            array (
                $nrorg,
                $cdFilialO,
                $cdpratoO,
                $cdFilAuxPratO
        ) );

        $receitasPadrao = Recepadr::getObjectsByWhere (
            "CDPRATO = ?  AND NRORG = ? AND CDFILAUXPRAT = ?",
            array (
                $cdpratoD,
                $nrorg,
                $filAuxPratD
        ) );

        if ($parametros === 'S') {
            self::deletaReceita ( $receitasPadrao );
        }
        if(!$updatedRows) {
            $updatedRows = array();
        }

        $connection = \SetForms2\Shared\Registry::getEntityManager ();
        $connection->beginTransaction ();
        try {
			/**
			 *
			 * @var $receita \Planejamento\Entities\Base\Recefili
			 */
			foreach ( $receitasLocal as $receitaLocal ) {
				$existente = self::validaProdutoIgual($receitaLocal, $receitasPadrao, $parametros);
				if(!$existente){
					$receitaPadrao = new Recepadr ();
					$receitaPadrao->setQtprodprat ( $receitaLocal->getQtprodrecloc () );
					$receitaPadrao->setSgunidade ( $receitaLocal->getSgunidade () );
					$receitaPadrao->setIdqtdefixpr ( $receitaLocal->getIdqtdefixlo () );
					$receitaPadrao->setVrpefatcocpr ( $receitaLocal->getVrpefatcoclo () );
					$receitaPadrao->setVrpefatcorpr ( $receitaLocal->getVrpefatcorlo () );
					$receitaPadrao->setHrtemppreppr ( $receitaLocal->getHrtemppreplo () );
					$receitaPadrao->setQtbrutaprunr ( $receitaLocal->getQtbrutalounr () );
					$receitaPadrao->setQtbrutapr ( $receitaLocal->getQtbrutalo () );
					$receitaPadrao->setIdprodbasepr ( $receitaLocal->getIdprodbaselo () );
					$receitaPadrao->setVrpefatnutpr ( $receitaLocal->getVrpefatnutlo () );
					$receitaPadrao->setQtcalcnutrpr ( $receitaLocal->getQtcalcnutrlo () );
					$receitaPadrao->setIdativo ( $receitaLocal->getIdativo () );
					$receitaPadrao->setNrorg ( $receitaLocal->getNrorg () );
					$receitaPadrao->setCdfilauxprat ( $filAuxPratD );
					$receitaPadrao->setCdproduto ( $receitaLocal->getCdproduto () );
					$receitaPadrao->setIdutcompentdirp ( $receitaLocal->getIdutcompentdirf () );
					$receitaPadrao->setCdprato ( $cdpratoD );
					$receitaPadrao->setDtinclusao ( $dataAtual );
					$receitaPadrao->setDtultatu ( $dataAtual );
					$receitaPadrao->setCdoperinclusao ( $operador );
					$receitaPadrao->setCdoperultatu ( $operador );
					foreach ( $updatedRows as $row ) {
						if ($receitaPadrao->getCdproduto () == $row ['CODPRODUTO']) {
							$receitaPadrao->setQtprodprat ( $row ['QTDLIQUIDA'] );
							$receitaPadrao->setSgunidade ( $row ['SGUNIDADE'] );
							$receitaPadrao->setIdqtdefixpr ( $row ['QTDFIXA'] );
							$receitaPadrao->setVrpefatcocpr ( $row ['GANHOCOCCAO'] );
							$receitaPadrao->setVrpefatcorpr ( $row ['PERDALIMP'] );
							$receitaPadrao->setHrtemppreppr ( $row ['TEMPOPREP'] );
							$receitaPadrao->setQtbrutaprunr ( $row ['QTDBRUTA'] );
							$receitaPadrao->setQtbrutapr ( $row ['QTDEREQUERIDA'] );
							$receitaPadrao->setIdprodbasepr ( $row ['PRBASE'] );
							$receitaPadrao->setVrpefatnutpr ( $row ['APROVNUTRI'] );
							$receitaPadrao->setQtcalcnutrpr ( $row ['QTDECALCULONUTRI'] );
							continue 1;
						}
					}
					$receitaPadrao->persist ();
                    $connection->flush ();
				}
			}

			$connection->commit ();
			return true;
		} catch ( \Exception $e ) {
			tk_warning ( $e->getMessage () );
			$connection->rollback ();
			return false;
		}
	}

    // SERVICO PARA PADRAO
    public static function importaReceitaServicoParaPadrao(
        $cdpratoO, $cdfilialO, $cdservicoO, $filAuxPratO,
        $cdpratoD, $filAuxPratD,
        $nrorg, $dataAtual, $operador, $parametros, $updatedRows
    ) {
        $itemsServico = Receserv::getObjectsByWhere (
            "NRORG = ? AND CDPRATO = ? AND CDSERVFILI = ? AND CDFILIAL = ? AND CDFILAUXPRAT = ?",
            array (
                $nrorg,
                $cdpratoO,
                $cdservicoO,
                $cdfilialO,
                $filAuxPratO
            ) );

        $itemsPadrao = Recepadr::getObjectsByWhere (
            "CDPRATO = ?  AND NRORG = ? AND CDFILAUXPRAT = ?",
            array (
                $cdpratoD,
                $nrorg,
                $filAuxPratD
            ) );
        if ($parametros == 'S') {
            self::deletaReceita ( $itemsPadrao );
        }

        if(!$updatedRows) {
            $updatedRows = array();
        }

        try {
            $connection = \Setforms2\Shared\Registry::getEntityManager ();
            $connection->beginTransaction ();

            foreach ( $itemsServico as $itemServico ) {
                $existente = self::validaProdutoIgual($itemServico, $itemsPadrao, $parametros);
                if(!$existente){
                    $receitaPadrao = new Recepadr ();
                    $receitaPadrao->setQtprodprat ( $itemServico->getQtprodrecser () );
                    $receitaPadrao->setQtprodprat ( $itemServico->getQtprodrecser () );
                    $receitaPadrao->setSgunidade ( $itemServico->getSgunidade () );
                    $receitaPadrao->setIdqtdefixpr ( $itemServico->getIdqtdefixse () );
                    $receitaPadrao->setVrpefatcocpr ( $itemServico->getVrpefatcocse () );
                    $receitaPadrao->setVrpefatcorpr ( $itemServico->getVrpefatcorse () );
                    $receitaPadrao->setHrtemppreppr ( $itemServico->getHrtempprepse () );
                    $receitaPadrao->setQtbrutaprunr ( $itemServico->getQtbrutaseunr () );
                    $receitaPadrao->setQtbrutapr ( $itemServico->getQtbrutase () );
                    $receitaPadrao->setIdprodbasepr ( $itemServico->getIdprodbasese () );
                    $receitaPadrao->setVrpefatnutpr ( $itemServico->getVrpefatnutse () );
                    $receitaPadrao->setQtcalcnutrpr ( $itemServico->getQtcalcnutrse () );
                    $receitaPadrao->setIdativo ( $itemServico->getIdativo () );
                    $receitaPadrao->setNrorg ( $itemServico->getNrorg () );
                    $receitaPadrao->setCdfilauxprat ( $filAuxPratD );
                    $receitaPadrao->setCdproduto ( $itemServico->getCdproduto () );
                    $receitaPadrao->setIdutcompentdirp ( $itemServico->getIdutcompentdirs () );
                    $receitaPadrao->setCdprato ( $cdpratoD );
                    $receitaPadrao->setDtinclusao ( $dataAtual );
                    $receitaPadrao->setDtultatu ( $dataAtual );
                    $receitaPadrao->setCdoperinclusao ( $operador );
                    $receitaPadrao->setCdoperultatu ( $operador );
                    foreach ( $updatedRows as $row ) {
                        if ($receitaPadrao->getCdproduto () == $row ['CODPRODUTO']) {
                            $receitaPadrao->setQtprodprat ( $row ['QTDLIQUIDA'] );
                            $receitaPadrao->setSgunidade ( $row ['UNIDADEMEDIDA'] );
                            $receitaPadrao->setIdqtdefixpr ( $row ['QTDFIXA'] );
                            $receitaPadrao->setVrpefatcocpr ( $row ['GANHOCOCCAO'] );
                            $receitaPadrao->setVrpefatcorpr ( $row ['PERDALIMP'] );
                            $receitaPadrao->setHrtemppreppr ( $row ['TEMPOPREP'] );
                            $receitaPadrao->setQtbrutaprunr ( $row ['QTDBRUTA'] );
                            $receitaPadrao->setQtbrutapr ( $row ['QTDEREQUERIDA'] );
                            $receitaPadrao->setIdprodbasepr ( $row ['PRBASE'] );
                            $receitaPadrao->setVrpefatnutpr ( $row ['APROVNUTRI'] );
                            $receitaPadrao->setQtcalcnutrpr ( $row ['QTDECALCULONUTRI'] );
                            $receitaPadrao->persist ();
                            break;
                        }
                    }
                    $receitaPadrao->persist ();
                    $connection->flush ();
                }
            }
            $connection->commit ();
            return true;
        } catch ( \Exception $e ) {
            tk_message ( $e->getMessage () );
            $connection->rollback ();
            return false;
        }
    }


    public static function importacaoReceitaPadraoParaLocal(
        $cdpratoO, $cdFilAuxPratO,
        $cdpratoD, $cdfilialD, $cdFilAuxPratD,
        $nrorg, $dataAtual, $operador, $parametro, $updatedRows
    ) {
        /**
         *
         * @var $receitasPadrao Recepadr
         */
        $receitasPadrao = Recepadr::getObjectsByWhere (
            "CDPRATO = ?  AND NRORG = ? AND CDFILAUXPRAT = ?",
            array (
                $cdpratoO,
                $nrorg,
                $cdFilAuxPratO
            ) );

        $itemsReceitaLocal = Recefili::getObjectsByWhere (
            "NRORG = ? AND CDFILIAL = ? AND CDPRATO = ? AND CDFILAUXPRAT = ?",
            array (
                $nrorg,
                $cdfilialD,
                $cdpratoD,
                $cdFilAuxPratD
            ) );
        if ($parametro === 'S') {

            self::deletaReceita ( $itemsReceitaLocal );
        }
        if (!$updatedRows) {
            $updatedRows = array();
        }

        $connection = \Setforms2\Shared\Registry::getEntityManager ();
        $connection->beginTransaction ();
        try {
            /**
             *
             * @var $receitaPadrao \Planejamento\Entities\Base\Recepadr
             */
            foreach ( $receitasPadrao as $receitaPadrao ) {
                $existente = self::validaProdutoIgual($receitaPadrao, $itemsReceitaLocal, $parametro);
                if(!$existente){
                    $receitaLocal = new Recefili ();
                    $receitaLocal->setQtprodrecloc ( $receitaPadrao->getQtprodprat () );
                    $receitaLocal->setSgunidade ( $receitaPadrao->getSgunidade () );
                    $receitaLocal->setIdqtdefixlo ( $receitaPadrao->getIdqtdefixpr () );
                    $receitaLocal->setVrpefatcoclo ( $receitaPadrao->getVrpefatcocpr () );
                    $receitaLocal->setVrpefatcorlo ( $receitaPadrao->getVrpefatcorpr () );
                    $receitaLocal->setHrtemppreplo ( $receitaPadrao->getHrtemppreppr () );
                    $receitaLocal->setQtbrutalounr ( $receitaPadrao->getQtbrutaprunr () );
                    $receitaLocal->setQtbrutalo ( $receitaPadrao->getQtbrutapr () );
                    $receitaLocal->setIdprodbaselo ( $receitaPadrao->getIdprodbasepr () );
                    $receitaLocal->setVrpefatnutlo ( $receitaPadrao->getVrpefatnutpr () );
                    $receitaLocal->setQtcalcnutrlo ( $receitaPadrao->getQtcalcnutrpr () );
                    $receitaLocal->setIdativo ( $receitaPadrao->getIdativo () );
                    $receitaLocal->setNrorg ( $receitaPadrao->getNrorg () );
                    $receitaLocal->setCdproduto ( $receitaPadrao->getCdproduto () );
                    $receitaLocal->setIdutcompentdirf ( $receitaPadrao->getIdutcompentdirp () );
                    $receitaLocal->setCdfilial ( $cdfilialD );
                    $receitaLocal->setCdfilauxprat ( $cdFilAuxPratD );
                    $receitaLocal->setCdprato ( $cdpratoD );
                    $receitaLocal->setDtinclusao ( $dataAtual );
                    $receitaLocal->setDtultatu ( $dataAtual );
                    $receitaLocal->setCdoperinclusao ( $operador );
                    $receitaLocal->setCdoperultatu ( $operador );
                    foreach ( $updatedRows as $row ) {
                        if ($receitaLocal->getCdproduto () == $row ['CODPRODUTO']) {
                            $receitaLocal->setQtprodrecloc ( $row ['QTDLIQUIDA'] );
                            $receitaLocal->setSgunidade ( $row ['UNIDADEMEDIDA'] );
                            $receitaLocal->setIdqtdefixlo ( $row ['QTDFIXA'] );
                            $receitaLocal->setVrpefatcoclo ( $row ['GANHOCOCCAO'] );
                            $receitaLocal->setVrpefatcorlo ( $row ['PERDALIMP'] );
                            $receitaLocal->setHrtemppreplo ( $row ['TEMPOPREP'] );
                            $receitaLocal->setQtbrutalounr ( $row ['QTDBRUTA'] );
                            $receitaLocal->setQtbrutalo ( $row ['QTDEREQUERIDA'] );
                            $receitaLocal->setIdprodbaselo ( $row ['PRBASE'] );
                            $receitaLocal->setVrpefatnutlo ( $row ['APROVNUTRI'] );
                            $receitaLocal->setQtcalcnutrlo ( $row ['QTDECALCULONUTRI'] );
                            continue 1;
                        }
                    }
                    $receitaLocal->persist ();
                    $connection->flush ();
                }
            }
            $connection->commit ();
            return true;
        } catch ( \Exception $e ) {
            tk_warning ( $e->getMessage () );
            $connection->rollback ();
            return false;
        }
    }

	// Local para Local
	public static function importaReceitaLocalParaLocal (
        $cdpratoO, $cdFilialO, $cdFilAuxPratO,
        $cdpratoD, $cdfilialD, $filAuxPratD,
        $nrorg, $dataAtual, $operador, $parametro, $updatedRows
    ) {
		$receitasLocalO = Recefili::getObjectsByWhere (
            "NRORG = ? AND CDFILIAL = ? AND CDPRATO = ? AND CDFILAUXPRAT = ?",
            array (
                $nrorg,
                $cdFilialO,
                $cdpratoO,
                $cdFilAuxPratO
            ) );

        $receitasLocal = Recefili::getObjectsByWhere (
            "NRORG = ? AND CDFILIAL = ? AND CDPRATO = ? AND CDFILAUXPRAT = ?",
            array (
                $nrorg,
                $cdfilialD,
                $cdpratoD,
                $filAuxPratD
        ) );

        if ($parametro == 'S') {
            self::deletaReceita ( $receitasLocal );
        }

        if(!$updatedRows) {
            $updatedRows  = array();
        }

        try {
            $connection = \Setforms2\Shared\Registry::getEntityManager ();
            $connection->beginTransaction ();

            foreach ( $receitasLocalO as $itemLocal ) {
				$existente = self::validaProdutoIgual($itemLocal, $receitasLocal, $parametro);
				if(!$existente){
					$receitaLocal = new Recefili ();
					$receitaLocal->setQtprodrecloc ( $itemLocal->getQtprodrecloc() );
					$receitaLocal->setSgunidade ( $itemLocal->getSgunidade() );
					$receitaLocal->setIdqtdefixlo ( $itemLocal->getIdqtdefixlo() );
					$receitaLocal->setVrpefatcoclo ( $itemLocal->getVrpefatcoclo() );
					$receitaLocal->setVrpefatcorlo ( $itemLocal->getVrpefatcorlo() );
					$receitaLocal->setHrtemppreplo ( $itemLocal->getHrtemppreplo() );
					$receitaLocal->setQtbrutalounr ( $itemLocal->getQtbrutalounr() );
					$receitaLocal->setQtbrutalo ( $itemLocal->getQtbrutalo() );
					$receitaLocal->setIdprodbaselo ( $itemLocal->getIdprodbaselo() );
					$receitaLocal->setVrpefatnutlo ( $itemLocal->getVrpefatnutlo() );
					$receitaLocal->setQtcalcnutrlo ( $itemLocal->getQtcalcnutrlo() );
					$receitaLocal->setIdativo ( $itemLocal->getIdativo () );
					$receitaLocal->setNrorg ( $itemLocal->getNrorg () );
					$receitaLocal->setCdproduto ( $itemLocal->getCdproduto () );
					$receitaLocal->setIdutcompentdirf ( $itemLocal->getIdutcompentdirf() );
					$receitaLocal->setCdfilial ( $cdfilialD );
					$receitaLocal->setCdfilauxprat ( $filAuxPratD);
					$receitaLocal->setCdprato ( $cdpratoD );
					$receitaLocal->setDtinclusao ( $dataAtual );
					$receitaLocal->setDtultatu ( $dataAtual );
					$receitaLocal->setCdoperinclusao ( $operador );
					$receitaLocal->setCdoperultatu ( $operador );
					foreach ( $updatedRows as $row ) {
						if ($receitaLocal->getCdproduto () == $row ['CODPRODUTO']) {
							$receitaLocal->setQtprodrecloc ( $row ['QTDLIQUIDA'] );
							$receitaLocal->setSgunidade ( $row ['UNIDADEMEDIDA'] );
							$receitaLocal->setIdqtdefixlo ( $row ['QTDFIXA'] );
							$receitaLocal->setVrpefatcoclo ( $row ['GANHOCOCCAO'] );
							$receitaLocal->setVrpefatcorlo ( $row ['PERDALIMP'] );
							$receitaLocal->setHrtemppreplo ( $row ['TEMPOPREP'] );
							$receitaLocal->setQtbrutalounr ( $row ['QTDBRUTA'] );
							$receitaLocal->setQtbrutalo ( $row ['QTDEREQUERIDA'] );
							$receitaLocal->setIdprodbaselo ( $row ['PRBASE'] );
							$receitaLocal->setVrpefatnutlo ( $row ['APROVNUTRI'] );
							$receitaLocal->setQtcalcnutrlo ( $row ['QTDECALCULONUTRI'] );
							continue 1;
						}
					}
					$receitaLocal->persist ();
                    $connection->flush ();
                }
            }
			$connection->commit ();
			return true;
		} catch ( \Exception $e ) {
			tk_message ( $e->getMessage () );
			$connection->rollback ();
			return false;
		}
	}

	// Servico para Local
	public static function importaReceitaServicoParaLocal(
        $cdpratoO, $cdfilialO, $cdservicoO, $filAuxPratO,
        $cdpratoD, $cdfilialD, $filAuxPratD,
        $nrorg, $dataAtual, $operador, $parametro, $updatedRows)
    {
		$receitasServico = Receserv::getObjectsByWhere (
        "NRORG = ? AND CDPRATO = ? AND CDSERVFILI = ? AND CDFILIAL = ? AND CDFILAUXPRAT = ?",
        array (
            $nrorg,
            $cdpratoO,
            $cdservicoO,
            $cdfilialO,
            $filAuxPratO
        ) );

        $receitasLocal = Recefili::getObjectsByWhere (
            "NRORG = ? AND CDFILIAL = ? AND CDPRATO = ? AND CDFILAUXPRAT = ?",
            array (
                $nrorg,
                $cdfilialD,
                $cdpratoD,
                $filAuxPratD
        ) );

        if ($parametro == 'S') {
            self::deletaReceita ( $receitasLocal );
        }

        if(!$updatedRows) {
            $updatedRows  = array();
        }

        try {
            $connection = \Setforms2\Shared\Registry::getEntityManager ();
            $connection->beginTransaction ();

            foreach ( $receitasServico as $itemServico ) {
				$existente = self::validaProdutoIgual($itemServico, $receitasLocal, $parametro);
				if(!$existente){
					$receitaLocal = new Recefili ();
					$receitaLocal->setQtprodrecloc ( $itemServico->getQtprodrecser () );
					$receitaLocal->setSgunidade ( $itemServico->getSgunidade () );
					$receitaLocal->setIdqtdefixlo ( $itemServico->getIdqtdefixse () );
					$receitaLocal->setVrpefatcoclo ( $itemServico->getVrpefatcocse () );
					$receitaLocal->setVrpefatcorlo ( $itemServico->getVrpefatcorse () );
					$receitaLocal->setHrtemppreplo ( $itemServico->getHrtempprepse () );
					$receitaLocal->setQtbrutalounr ( $itemServico->getQtbrutaseunr () );
					$receitaLocal->setQtbrutalo ( $itemServico->getQtbrutase () );
					$receitaLocal->setIdprodbaselo ( $itemServico->getIdprodbasese () );
					$receitaLocal->setVrpefatnutlo ( $itemServico->getVrpefatnutse () );
					$receitaLocal->setQtcalcnutrlo ( $itemServico->getQtcalcnutrse () );
					$receitaLocal->setIdativo ( $itemServico->getIdativo () );
					$receitaLocal->setNrorg ( $itemServico->getNrorg () );
					$receitaLocal->setCdproduto ( $itemServico->getCdproduto () );
					$receitaLocal->setIdutcompentdirf ( $itemServico->getIdutcompentdirs () );
					$receitaLocal->setCdfilial ( $cdfilialD );
					$receitaLocal->setCdfilauxprat ( $filAuxPratD);
					$receitaLocal->setCdprato ( $cdpratoD );
					$receitaLocal->setDtinclusao ( $dataAtual );
					$receitaLocal->setDtultatu ( $dataAtual );
					$receitaLocal->setCdoperinclusao ( $operador );
					$receitaLocal->setCdoperultatu ( $operador );
					foreach ( $updatedRows as $row ) {
						if ($receitaLocal->getCdproduto () == $row ['CODPRODUTO']) {
							$receitaLocal->setQtprodrecloc ( $row ['QTDLIQUIDA'] );
							$receitaLocal->setSgunidade ( $row ['UNIDADEMEDIDA'] );
							$receitaLocal->setIdqtdefixlo ( $row ['QTDFIXA'] );
							$receitaLocal->setVrpefatcoclo ( $row ['GANHOCOCCAO'] );
							$receitaLocal->setVrpefatcorlo ( $row ['PERDALIMP'] );
							$receitaLocal->setHrtemppreplo ( $row ['TEMPOPREP'] );
							$receitaLocal->setQtbrutalounr ( $row ['QTDBRUTA'] );
							$receitaLocal->setQtbrutalo ( $row ['QTDEREQUERIDA'] );
							$receitaLocal->setIdprodbaselo ( $row ['PRBASE'] );
							$receitaLocal->setVrpefatnutlo ( $row ['APROVNUTRI'] );
							$receitaLocal->setQtcalcnutrlo ( $row ['QTDECALCULONUTRI'] );
							continue 1;
						}
					}
					$receitaLocal->persist ();
                    $connection->flush ();
                }
            }
			$connection->commit ();
			return true;
		} catch ( \Exception $e ) {
			tk_message ( $e->getMessage () );
			$connection->rollback ();
			return false;
		}
	}


    public static function importacaoReceitaPadraoParaServico(
        $cdpratoO, $cdFilAuxPratO,
        $cdpratoD, $cdfilialD, $cdservicoD, $cdFilAuxPratD,
        $nrorg, $dataAtual, $operador, $parametro, $updatedRows
    ) {
        /**
         *
         * @var $receitasPadrao Recepadr
         */
        $receitasPadrao = Recepadr::getObjectsByWhere (
            "CDPRATO = ?  AND NRORG = ? AND CDFILAUXPRAT = ?",
            array (
                $cdpratoO,
                $nrorg,
                $cdFilAuxPratO
            ) );
        $itemsServico = Receserv::getObjectsByWhere (
            "CDPRATO = ? AND CDFILIAL = ? AND NRORG = ? AND CDSERVFILI = ? AND CDFILAUXPRAT = ?",
            array (
                $cdpratoD,
                $cdfilialD,
                $nrorg,
                $cdservicoD,
                $cdFilAuxPratD
            ) );

        if ($parametro === 'S') {
            self::deletaReceita ( $itemsServico );
        }

        if(!$updatedRows) {
            $updatedRows = array();
        }

        $connection = \Setforms2\Shared\Registry::getEntityManager ();
        $connection->beginTransaction ();
        try {
            /**
             *
             * @var $receitaPadrao \Planejamento\Entities\Base\Recepadr
             */
            foreach ( $receitasPadrao as $receitaPadrao ) {
                $existente = self::validaProdutoIgual($receitaPadrao, $itemsServico, $parametro);
                if(!$existente){
                    $receitaServico = new Receserv ();
                    $receitaServico->setCdproduto ( $receitaPadrao->getCdproduto () );
                    $receitaServico->setQtprodrecser ( $receitaPadrao->getQtprodprat () );
                    $receitaServico->setSgunidade ( $receitaPadrao->getSgunidade () );
                    $receitaServico->setIdqtdefixse ( $receitaPadrao->getIdqtdefixpr () );
                    $receitaServico->setVrpefatcocse ( $receitaPadrao->getVrpefatcocpr () );
                    $receitaServico->setVrpefatcorse ( $receitaPadrao->getVrpefatcorpr () );
                    $receitaServico->setHrtempprepse ( $receitaPadrao->getHrtemppreppr () );
                    $receitaServico->setQtbrutaseunr ( $receitaPadrao->getQtbrutaprunr () );
                    $receitaServico->setQtbrutase ( $receitaPadrao->getQtbrutapr () );
                    $receitaServico->setIdprodbasese ( $receitaPadrao->getIdprodbasepr () );
                    $receitaServico->setVrpefatnutse ( $receitaPadrao->getVrpefatnutpr () );
                    $receitaServico->setQtcalcnutrse ( $receitaPadrao->getQtcalcnutrpr () );
                    $receitaServico->setIdativo ( $receitaPadrao->getIdativo () );
                    $receitaServico->setNrorg ( $receitaPadrao->getNrorg () );
                    $receitaServico->setIdutcompentdirs ( $receitaPadrao->getIdutcompentdirp () );
                    $receitaServico->setCdfilial ( $cdfilialD );
                    $receitaServico->setCdservfili ( $cdservicoD );
                    $receitaServico->setCdfilauxprat ( $cdFilAuxPratD );
                    $receitaServico->setCdprato ( $cdpratoD );
                    $receitaServico->setDtinclusao ( $dataAtual );
                    $receitaServico->setDtultatu ( $dataAtual );
                    $receitaServico->setCdoperinclusao ( $operador );
                    $receitaServico->setCdoperultatu ( $operador );
                    foreach ( $updatedRows as $row ) {
                        if ($receitaServico->getCdproduto () == $row ['CODPRODUTO']) {
                            $receitaServico->setCdproduto ( $row ['CODPRODUTO'] );
                            $receitaServico->setQtprodrecser ( $row ['QTDLIQUIDA'] );
                            $receitaServico->setSgunidade ( $row ['UNIDADEMEDIDA'] );
                            $receitaServico->setIdqtdefixse ( $row ['QTDFIXA'] );
                            $receitaServico->setVrpefatcocse ( $row ['GANHOCOCCAO'] );
                            $receitaServico->setVrpefatcorse ( $row ['PERDALIMP'] );
                            $receitaServico->setHrtempprepse ( $row ['TEMPOPREP'] );
                            $receitaServico->setQtbrutaseunr ( $row ['QTDBRUTA'] );
                            $receitaServico->setQtbrutase ( $row ['QTDEREQUERIDA'] );
                            $receitaServico->setIdprodbasese ( $row ['PRBASE'] );
                            $receitaServico->setVrpefatnutse ( $row ['APROVNUTRI'] );
                            $receitaServico->setQtcalcnutrse ( $row ['QTDECALCULONUTRI'] );
                            continue 1;
                        }
                    }

                    $receitaServico->persist ();
                    $connection->flush ();
                }
            }
            $connection->commit ();
            return true;
        } catch ( \Exceprtion $e ) {
            tk_warning ( $e->getMessage () );
            $connection->rollback ();
            return false;
        }
    }


    public static function importacaoReceitaLocalParaServico(
        $cdpratoO, $cdfilialO, $filAuxPratO,
        $cdpratoD, $cdfilialD, $cdservicoD, $filAuxPratD,
        $nrorg, $dataAtual, $operador, $parametro, $updatedRows)
    {
        /**
         *
         * @var $receitasLocal \Planejamento\Entities\Recefili
         */
        $receitasLocal = Recefili::getObjectsByWhere (
            "NRORG = ? AND CDFILIAL = ? AND CDPRATO = ? AND CDFILAUXPRAT = ?",
            array(
                $nrorg,
                $cdfilialO,
                $cdpratoO,
                $filAuxPratO
            ) );

        $itemsServico = Receserv::getObjectsByWhere (
            "CDPRATO = ? AND CDFILAUXPRAT = ? AND CDFILIAL = ? AND NRORG = ? AND CDSERVFILI = ?",
            array(
                $cdpratoD,
                $filAuxPratD,
                $cdfilialD,
                $nrorg,
                $cdservicoD
            ) );

        if ($parametro === 'S') {
            self::deletaReceita ( $itemsServico );
        }

        if(!$updatedRows) {
            $updatedRows = array();
        }

        try {
            $connection = \Setforms2\Shared\Registry::getEntityManager ();
            $connection->beginTransaction ();
            /**
             *
             * @var $receitaLocal \Planejamento\Entities\Recefili
             */
            foreach ( $receitasLocal as $receitaLocal ) {
                $existente = self::validaProdutoIgual(
                    $receitaLocal, $itemsServico, $parametro
                );
                if (!$existente) {
                    $receitaServico = new Receserv ();
                    $receitaServico->setCdfilial($cdfilialD);
                    $receitaServico->setCdservfili($cdservicoD);
                    $receitaServico->setIdativo($receitaLocal->getIdativo());
                    $receitaServico->setCdproduto($receitaLocal->getCdproduto());
                    $receitaServico->setCdfilauxprat($filAuxPratD);
                    $receitaServico->setCdprato($cdpratoD);
                    $receitaServico->setNrorg($nrorg);
                    $receitaServico->setDtinclusao($dataAtual);
                    $receitaServico->setQtprodrecser(
                        $receitaLocal->getQtprodrecloc()
                    );
                    $receitaServico->setSgunidade($receitaLocal->getSgunidade());
                    $receitaServico->setIdqtdefixse(
                        $receitaLocal->getIdqtdefixlo()
                    );
                    $receitaServico->setVrpefatcocse(
                        $receitaLocal->getVrpefatcoclo()
                    );
                    $receitaServico->setVrpefatcorse(
                        $receitaLocal->getVrpefatcorlo()
                    );
                    $receitaServico->setHrtempprepse(
                        $receitaLocal->getHrtemppreplo()
                    );
                    $receitaServico->setQtbrutaseunr(
                        $receitaLocal->getQtbrutalounr()
                    );
                    $receitaServico->setQtbrutase($receitaLocal->getQtbrutalo());
                    $receitaServico->setIdprodbasese(
                        $receitaLocal->getIdprodbaselo()
                    );
                    $receitaServico->setVrpefatnutse(
                        $receitaLocal->getVrpefatnutlo()
                    );
                    $receitaServico->setQtcalcnutrse(
                        $receitaLocal->getQtcalcnutrlo()
                    );
                    $receitaServico->setIdutcompentdirs(
                        $receitaLocal->getIdutcompentdirf()
                    );
                    $receitaServico->setDtultatu($dataAtual);
                    $receitaServico->setCdoperinclusao($operador);
                    $receitaServico->setCdoperultatu($operador);
                    foreach ($updatedRows as $row) {
                        if ($row['CODPRODUTO'] == $receitaLocal->getCdproduto()) {
                            $receitaServico->setQtprodrecser(
                                $row ['QTDLIQUIDA']
                            );
                            $receitaServico->setSgunidade(
                                $row ['UNIDADEMEDIDA']
                            );
                            $receitaServico->setIdqtdefixse($row ['QTDFIXA']);
                            $receitaServico->setVrpefatcocse(
                                $row ['GANHOCOCCAO']
                            );
                            $receitaServico->setVrpefatcorse(
                                $row ['PERDALIMP']
                            );
                            $receitaServico->setHrtempprepse(
                                $row ['TEMPOPREP']
                            );
                            $receitaServico->setQtbrutaseunr($row ['QTDBRUTA']);
                            $receitaServico->setQtbrutase(
                                $row ['QTDEREQUERIDA']
                            );
                            $receitaServico->setIdprodbasese($row ['PRBASE']);
                            $receitaServico->setVrpefatnutse(
                                $row ['APROVNUTRI']
                            );
                            $receitaServico->setQtcalcnutrse(
                                $row ['QTDECALCULONUTRI']
                            );

                            continue 1;
                        }
                    }
                    $receitaServico->persist();
                    $connection->flush();
                }
            }

            $connection->commit ();
        } catch ( \Exception $e ) {
            tk_warning ( $e->getMessage () );
            $connection->rollback ();
            return false;
        }
        return true;
    }


    public static function importacaoReceitaServicoParaServico(
        $cdpratoO, $cdfilialO, $cdservicoO, $filAuxPratO,
        $cdpratoD, $cdfilialD, $cdservicoD, $filAuxPratD,
        $nrorg, $dataAtual, $operador, $parametro, $updatedRows)
    {
        // @var $receitaServicoOrigem Receserv
        $receitaServicoOrigem = Receserv::getObjectsByWhere (
            "CDPRATO = ? AND CDFILIAL = ? AND NRORG = ? AND CDSERVFILI = ? AND CDFILAUXPRAT = ?",
            array ($cdpratoO, $cdfilialO, $nrorg, $cdservicoO, $filAuxPratO) );

        // @var $receitaServicoDestino Receserv
        $receitaServicoDestino = Receserv::getObjectsByWhere (
            "CDPRATO = ? AND CDFILIAL = ? AND NRORG = ? AND CDSERVFILI = ? AND CDFILAUXPRAT = ?",
            array ($cdpratoD, $cdfilialD, $nrorg, $cdservicoD, $filAuxPratD) );

        if ($parametro === 'S') {
            self::deletaReceita ( $receitaServicoDestino );
        }
        if(!$updatedRows) {
            $updatedRows = array();
        }

        $connection = \Setforms2\Shared\Registry::getEntityManager ();
        $connection->beginTransaction ();
        try {
            /**
             *
             * @var $receitaOrigem \Planejamento\Entities\Receserv
             */
            foreach ( $receitaServicoOrigem as $receitaOrigem ) {
                $existente = self::validaProdutoIgual($receitaOrigem, $receitaServicoDestino, $parametro);
                if(!$existente){
                    $receitaServico = new Receserv ();
                    $receitaServico->setCdproduto ( $receitaOrigem->getCdproduto () );
                    $receitaServico->setQtprodrecser ( $receitaOrigem->getQtprodrecser());
                    $receitaServico->setSgunidade ( $receitaOrigem->getSgunidade () );
                    $receitaServico->setIdqtdefixse ( $receitaOrigem->getIdqtdefixse() );
                    $receitaServico->setVrpefatcocse ( $receitaOrigem->getVrpefatcocse() );
                    $receitaServico->setVrpefatcorse ( $receitaOrigem->getVrpefatcorse() );
                    $receitaServico->setHrtempprepse ( $receitaOrigem->getHrtempprepse() );
                    $receitaServico->setQtbrutaseunr ( $receitaOrigem->getQtbrutaseunr() );
                    $receitaServico->setQtbrutase ( $receitaOrigem->getQtbrutase() );
                    $receitaServico->setIdprodbasese ( $receitaOrigem->getIdprodbasese() );
                    $receitaServico->setVrpefatnutse ( $receitaOrigem->getVrpefatnutse() );
                    $receitaServico->setQtcalcnutrse ( $receitaOrigem->getQtcalcnutrse () );
                    $receitaServico->setIdativo ( $receitaOrigem->getIdativo () );
                    $receitaServico->setNrorg ( $receitaOrigem->getNrorg () );
                    $receitaServico->setIdutcompentdirs ( $receitaOrigem->getIdutcompentdirs () );
                    $receitaServico->setCdfilial ( $cdfilialD );
                    $receitaServico->setCdservfili ( $cdservicoD );
                    $receitaServico->setCdfilauxprat ( $filAuxPratD );
                    $receitaServico->setCdprato ( $cdpratoD );
                    $receitaServico->setDtinclusao ( $dataAtual );
                    $receitaServico->setDtultatu ( $dataAtual );
                    $receitaServico->setCdoperinclusao ( $operador );
                    $receitaServico->setCdoperultatu ( $operador );
                    foreach ( $updatedRows as $row ) {
                        if ($receitaServico->getCdproduto () == $row ['CODPRODUTO']) {
                            $receitaServico->setCdproduto ( $row ['CODPRODUTO'] );
                            $receitaServico->setQtprodrecser ( $row ['QTDLIQUIDA'] );
                            $receitaServico->setSgunidade ( $row ['UNIDADEMEDIDA'] );
                            $receitaServico->setIdqtdefixse ( $row ['QTDFIXA'] );
                            $receitaServico->setVrpefatcocse ( $row ['GANHOCOCCAO'] );
                            $receitaServico->setVrpefatcorse ( $row ['PERDALIMP'] );
                            $receitaServico->setHrtempprepse ( $row ['TEMPOPREP'] );
                            $receitaServico->setQtbrutaseunr ( $row ['QTDBRUTA'] );
                            $receitaServico->setQtbrutase ( $row ['QTDEREQUERIDA'] );
                            $receitaServico->setIdprodbasese ( $row ['PRBASE'] );
                            $receitaServico->setVrpefatnutse ( $row ['APROVNUTRI'] );
                            $receitaServico->setQtcalcnutrse ( $row ['QTDECALCULONUTRI'] );
                            continue 1;
                        }
                    }

                    $receitaServico->persist ();
                    $connection->flush ();
                }
            }
            $connection->commit ();
            return true;
        } catch ( \Exception $e ) {
            tk_warning ( $e->getMessage () );
            $connection->rollback ();
            return false;
        }
    }

    /**
	 * valida se a receita foi validada
	 *
	 * @author paulosoares paulo.soares@teknisa.com
	 * @param array $updatedRows        	
	 * @return boolean
	 */
	public static function validaUpdatedRows($updatedRows) {
		if (empty ( $updatedRows )) {
			return true;
		}
		return false;
	}
	
	/**
	 * valida a importação atraves do idativo
	 *
	 * @author paulosoares paulo.soares@teknisa.com
	 * @param string $idativo        	
	 * @return boolean
	 */
	public static function validaIdAtivo($idativo) {
		if ($idativo == 'N' or empty($idativo)) {
			return true;
		}
		return false;
	}
	
	/**
	 * valida a importacao da receita atraves do parametro
	 * somente para importaçoes de origem da receita padrao
	 *
	 * @author paulosoares paulo.soares@teknisa.com
	 * @param unknown $cdfilial        	
	 * @return boolean
	 */
	public static function validaimportacaoPadrao($cdfilial, $updatedRows) {
		$parametro = Paramgeral::getObjectByWhere ( "CDFILIAL = ? ", array (
				$cdfilial 
		) );
		
		if(is_object($parametro))
			$id = $parametro->getIdrecrevicop ();
		else 
			$id = 'S';
		
		if ($id == 'N') {
			if (empty ( $updatedRows )) {
				throw new \Exception ( tk_get_message_by_name ( self::MSG_REVISAR_RECEITA ) );
			}
		}
	}
	
	/**
	 * valida se o destino da importacao e igual a origem
	 *
	 * @author paulosoares paulo.soares@teknisa.com
	 * @param string $destino        	
	 * @param string $origem        	
	 * @return boolean
	 */
	public static function validaDestinoOrigem($destino, $origem) {
		if ($destino == $origem) {
			return true;
		}
		return false;
	}
	
	/**
	 * deleta a receita se a opcao sobrepor for selecionada
	 *
	 * @author paulosoares paulo.soares@teknisa.com
	 * @param array $obj        	
	 */
	public static function deletaReceita($objs) {
		$connection = \Setforms2\Shared\Registry::getEntityManager();
		$connection->beginTransaction();
		try {
            foreach ( $objs as $obj ) {
				$obj->delete();
                $connection->flush();
			}
            $connection->commit();
		} catch ( \Exception $e ) {
			tk_message( $e->getMessage() );
			$connection->rollback();
		}

        return true;
	}
	
	/**
	 * verifica se o produto ja existe na receita destino
	 * 
	 * @param $receitaOrigem
	 * @param $receitasDestino
	 * @return boolean
	 */
	public static function validaProdutoIgual($receitaOrigem, $receitasDestino, $parametro){
		if($parametro != 'S' && empty($receitasDestino) == false){
			$origem = $receitaOrigem->getCdproduto();
			foreach ($receitasDestino as $receitaDestino){
				$destino =  $receitaDestino->getCdproduto();
				if($origem == $destino){
					$existente = true;
					break;
				} else{
					$existente = false;
				}
			}
		} else{
			$existente = false;
		}
		return $existente;
	}
}
