/* Tabela DESCMENSCIA: DESCMENSCIA */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela DESCMENSCIA */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela VOOTRECHO,
             utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_COC_DESCMENSCIA
AFTER DELETE OR INSERT OR UPDATE
ON DESCMENSCIA FOR EACH ROW
DECLARE
  V_USUARIO    VARCHAR2(40);
  V_TIPO       VARCHAR2(1);
  V_ITPESQ     VARCHAR2(40);
  V_DESC       VARCHAR2(500);
  V_DTOPER     DATE;
  V_DSIP       VARCHAR2(50);
  V_DSUSUARIO  VARCHAR2(50);
  V_DSRDM      VARCHAR2(50);
  V_DSMETODO   VARCHAR2(250);
  V_DSOPERADOR VARCHAR2(12);
BEGIN
   V_TIPO := '0';
   V_DESC := '';
   WEBTUNNING(V_DSIP,
              V_DSUSUARIO,
              V_DSRDM,
              V_DSMETODO,
              V_DSOPERADOR);
   IF DELETING THEN      
      IF :OLD.CDFILIAL IS NOT NULL THEN
         V_DESC := V_DESC || 'CdFilial=' || :OLD.CDFILIAL;
      END IF;
      
      IF :OLD.CDCIA IS NOT NULL THEN
         V_DESC := V_DESC || ' Cia=' || :OLD.CDCIA;
      END IF;
      
      IF :OLD.DTDESCCIA IS NOT NULL THEN
         V_DESC := V_DESC || ' DtDescCia=' || :OLD.DTDESCCIA;
      END IF;
      
      IF :OLD.VRPERDESCCIA IS NOT NULL THEN
         V_DESC := V_DESC || ' VrPerDescCia=' || :OLD.VRPERDESCCIA;
      END IF;
      
      IF :OLD.DTULTATUDESC IS NOT NULL THEN
         V_DESC := V_DESC || ' DtUltAtuDesc=' || :OLD.DTULTATUDESC;
      END IF;
            
      V_TIPO   := '3';
      V_ITPESQ := :OLD.CDCIA || '|' || :OLD.DTDESCCIA;
   ELSE
      IF UPDATING THEN
         IF (:OLD.CDFILIAL     <> :NEW.CDFILIAL     ) OR
            (:OLD.CDCIA        <> :NEW.CDCIA        ) OR
            (:OLD.DTDESCCIA    <> :NEW.DTDESCCIA    ) OR
            (:OLD.VRPERDESCCIA <> :NEW.VRPERDESCCIA ) OR
            (NVL(:OLD.DTULTATUDESC, SYSDATE) <> NVL(:NEW.DTULTATUDESC, SYSDATE)) THEN 
                        
            IF NVL(:OLD.CDFILIAL, ' ') <> NVL(:NEW.CDFILIAL ,' ') THEN
               V_DESC := V_DESC || 'CdFilial=' || :OLD.CDFILIAL || '|' || :NEW.CDFILIAL;
            END IF;
            
            IF NVL(:OLD.CDCIA, ' ') <> NVL(:NEW.CDCIA, ' ') THEN
               V_DESC := V_DESC || ' Cia=' || :OLD.CDCIA || '|' || :NEW.CDCIA;
            END IF;
            
            IF NVL(:OLD.DTDESCCIA, SYSDATE) <> NVL(:NEW.DTDESCCIA, SYSDATE) THEN
               V_DESC := V_DESC || ' DtDescCia=' || :OLD.DTDESCCIA || '|' || :NEW.DTDESCCIA;
            END IF;
            
            IF NVL(:OLD.VRPERDESCCIA, 0) <> NVL(:NEW.VRPERDESCCIA, 0) THEN
               V_DESC := V_DESC || ' VrPerDescCia=' || :OLD.VRPERDESCCIA || '|' || :NEW.VRPERDESCCIA;
            END IF;
            
            IF NVL(:OLD.DTULTATUDESC, SYSDATE) <> NVL(:NEW.DTULTATUDESC, SYSDATE) THEN
               V_DESC := V_DESC || ' DtUltAtuDesc=' || :OLD.DTULTATUDESC || '|' || :NEW.DTULTATUDESC;
            END IF; 
            
            V_TIPO   := '2';
            V_ITPESQ := :OLD.CDCIA || '|' || :OLD.DTDESCCIA;
         END IF;
      ELSE
         IF NVL(:OLD.CDFILIAL, ' ') <> NVL(:NEW.CDFILIAL ,' ') THEN
            V_DESC := V_DESC || 'CdFilial=' || :NEW.CDFILIAL;
         END IF;
          
         IF NVL(:OLD.CDCIA, ' ') <> NVL(:NEW.CDCIA, ' ') THEN
            V_DESC := V_DESC || ' Cia=' || :NEW.CDCIA;
         END IF;
          
         IF NVL(:OLD.DTDESCCIA, SYSDATE) <> NVL(:NEW.DTDESCCIA, SYSDATE) THEN
            V_DESC := V_DESC || ' DtDescCia=' || :NEW.DTDESCCIA;
         END IF;
          
         IF NVL(:OLD.VRPERDESCCIA, 0) <> NVL(:NEW.VRPERDESCCIA, 0) THEN
            V_DESC := V_DESC || ' VrPerDescCia=' || :NEW.VRPERDESCCIA;
         END IF;
          
         IF NVL(:OLD.DTULTATUDESC, SYSDATE) <> NVL(:NEW.DTULTATUDESC, SYSDATE) THEN
            V_DESC := V_DESC || ' DtUltAtuDesc=' || :NEW.DTULTATUDESC;
         END IF;
                    
         V_TIPO   := '1';
         V_ITPESQ := :NEW.CDCIA || '|' || :NEW.DTDESCCIA;
      END IF;
   END IF;
   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER, IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER, CDFILLOGOPER)
            VALUES
               ('DESCMENSCIA', V_DTOPER, V_USUARIO, V_TIPO, V_ITPESQ, SUBSTR(V_DESC, 1, 300),
                V_DSRDM, V_DSIP, V_DSUSUARIO, V_DSMETODO, V_DSOPERADOR, NVL(:NEW.CDFILIAL, :OLD.CDFILIAL));
         END IF;
      END IF;
   END IF;
END;
/
-- VERSAO --
BEGIN ATUVEROBJ('LOG_COC_DESCMENSCIA','5.85.xxx'); END;
/
