package com.javaseleniumtemplate.pages.EstoquePages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;

public class TransferenciaDeEstoquePage extends PageBase {


    ///Evento de Loading da pagina
    By loadingWait = By.xpath("//*[@class='zh-loading-desc ng-binding']");
    //BUSCA DO PRODUTO ATRAVES DO FLOAT-CONTROL:
    By iconFloatLupa = By.xpath("//*[@data-zh-id='zh-floating-control-handle']");
    By iconReflesh = By.xpath("//*[@data-zh-id='2085279469498787152459']//*[@data-zh-icon='refresh no-border icon-white']");
    By campoProcurarFloatControl = By.xpath("//*[@id='popup']//*[@placeholder='Procurar']");

    //Filtro Inicial
    By clearFilter = By.xpath("//*[@data-zh-id='1246388498426628331083_filter_action_clear']");
    By IconeUnidade = By.xpath("//div[@id='NMFILIAL']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");

    //Unidade
    By SelecioanarUnidadeTransferenciaDeEstoque = By.xpath("//*[@data-zh-field-name='NMFILIAL']//*[.='HELA INGREDIENTES BRASIL']");
    By IconeData = By.xpath("//*[@id='DTMOVIESTQ']//*[@class='zh-icon zh-icon-calendar zh-icon-no-border']");

    //Data
    By DataEscolhidaInicial = By.xpath("//*[@id='zh-calendar-Calendar']//*[.='1']");
    By BtnOkFiltro = By.xpath("//*[@id='footer']/div[3]/ul/li/a/span");

    //Almoxarifado
    By AlmoxarifadoOrigem = By.xpath("//*[@data-zh-id='124638849817494643131129']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
    By AlmoxarifadoOrigemUnidade = By.xpath("//span[text()='HELA MATRIZ']");
    By AlmoxarifadoDestino = By.xpath("//*[@data-zh-id='1246388498209328871139']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
    By AlmoxarifadoDestinoUnidade = By.xpath("//span[text()='HELA LOJA']");

    //Aplicar
    By aplicarFiltro = By.xpath("//span[text() = 'Aplicar filtro']");

    //Adicionar itens
    By BtnAdicionar = By.xpath("//*[@data-zh-id='124638849835832787421155']");


    //Tela de Transferência de Estoque
    By Salvar = By.xpath("//span[text() = 'Salvar']");

    //Produtos
    By BtnAdicionar2 = By.xpath("//*[@data-zh-id='12463884989204280871103']");

    By IconeNome = By.xpath("//div[@id='NMPRODUTO']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
    By Produto = By.xpath("//span[text()='Hela Poultry Broth Paste Clear KG']");

    //Lote
    By selectLote = By.xpath("//*[@data-zh-id='7645275172186633453300']//*[@tabindex='0']");
    By loteExistente = By.xpath("//ul[@class='list zh-new-select-list']/li[1]");
    By IconeLote = By.xpath("//div[@id='NRLOTEESTQ']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");

    By Lote = By.xpath("//span[text()='00231100']");

    //Confirmar
    By Confirmar = By.xpath("//span[text()='Confirmar']");

    //Quantidade
    By Quantidade = By. id("QTTOTLANCTO");

    //Adicionar
    By Adicionar = By.xpath("//span[text()='Adicionar']");

    //Salvar
    By Salvar2 = By.xpath("//*[@data-zh-id='12463884981816228916106']");


    //Editar Transferencia de Estoque

    By AlmoxarifadoEditado = By.xpath("//span[text()='HELA MATRIZ']");
    By Editar = By.xpath("//*[@data-zh-id='124638849835161962861157']");
    By AbaProdutos = By.linkText("Produtos");
    By BtnAdicionar3 = By.xpath("//*[@data-zh-id='12463884989204280871103']");
    By ProdutoEditado = By.xpath("//span[text()='Geflugelbruhe Paste (Hela 7562510050001)']");
    By LoteEditado = By.xpath("//span[text()='EST-231100']");





    //Excluir
    By BtnAlmoxarifadoExcluir = By.xpath("//span[text()='HELA MATRIZ']");
    By Excluir = By.xpath("//*[@data-zh-id='124638849827065391441159']");
    By BtnConfirmar = By.xpath("//span[text()='Sim']");


    public void preencherFiltroTransferenciaDeEstoque(String desUnidade, String almoxarifadoOrigem, String almoxarifadoDestino) {
        //Fltro Inicial
        click(clearFilter);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(IconeUnidade);
        click(IconeUnidade);

        //Start FLoat Control
        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        click(campoProcurarFloatControl);
        sendKeys(campoProcurarFloatControl, desUnidade);
        waitForInvisibilityOfElementLocated(loadingWait);
        //End search Float Control

        waitForVisibilityOfElementLocated(SelecioanarUnidadeTransferenciaDeEstoque);
        click(SelecioanarUnidadeTransferenciaDeEstoque);
        waitForInvisibilityOfElementLocated(loadingWait);

        waitForVisibilityOfElementLocated(IconeData);
        click(IconeData);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(DataEscolhidaInicial);
        click(DataEscolhidaInicial);

        waitForVisibilityOfElementLocated(BtnOkFiltro);
        click(BtnOkFiltro);
        waitForInvisibilityOfElementLocated(loadingWait);

        //Almoxarifado
        waitForVisibilityOfElementLocated(AlmoxarifadoOrigem);
        click(AlmoxarifadoOrigem);
        waitForInvisibilityOfElementLocated(loadingWait);

        //Start search float control
        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        click(campoProcurarFloatControl);
        sendKeys(campoProcurarFloatControl, almoxarifadoOrigem);
        waitForInvisibilityOfElementLocated(loadingWait);
        click(AlmoxarifadoOrigemUnidade);
        waitForInvisibilityOfElementLocated(loadingWait);

        //End float Control

        waitForVisibilityOfElementLocated(AlmoxarifadoDestino);
        click(AlmoxarifadoDestino);
        waitForInvisibilityOfElementLocated(loadingWait);

        //Start search float control
        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        click(campoProcurarFloatControl);
        sendKeys(campoProcurarFloatControl, almoxarifadoDestino);
        waitForInvisibilityOfElementLocated(loadingWait);
        click(AlmoxarifadoDestinoUnidade);
        waitForInvisibilityOfElementLocated(loadingWait);

        //Aplicar Filtro
        waitForVisibilityOfElementLocated(aplicarFiltro);
        click(aplicarFiltro);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
        public void realizarTransferenciaDeEstoque(String campoProduto,String campoLote,String campoQuantidade){

        //Realizar transferencia de estoque

   //Adicionar itens

        waitForVisibilityOfElementLocated(BtnAdicionar);
        click(BtnAdicionar);
        waitForInvisibilityOfElementLocated(BtnAdicionar);
        waitForInvisibilityOfElementLocated(loadingWait);

   //Tela de Transferência de Estoque
        waitForVisibilityOfElementLocated(Salvar);
        click(Salvar);
        waitForInvisibilityOfElementLocated(loadingWait);

    //Produtos
        waitForVisibilityOfElementLocated(BtnAdicionar2);
        click(BtnAdicionar2);
        waitForInvisibilityOfElementLocated(loadingWait);

   //Nome do Produto
        waitForVisibilityOfElementLocated(IconeNome);
        click(IconeNome);
        waitForInvisibilityOfElementLocated(loadingWait);

        //Start Float control
        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        click(campoProcurarFloatControl);
        sendKeys(campoProcurarFloatControl,campoProduto);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(Produto);
        click(Produto);
        waitForInvisibilityOfElementLocated(loadingWait);
        //End search float control

    //Lote
            waitForVisibilityOfElementLocated(selectLote);
            click(selectLote);
            waitForVisibilityOfElementLocated(loteExistente);
            click(loteExistente);
            waitForInvisibilityOfElementLocated(loadingWait);

            waitForVisibilityOfElementLocated(IconeLote);
            click(IconeLote);
            waitForInvisibilityOfElementLocated(loadingWait);


            //Start Float Control
            waitForVisibilityOfElementLocated(campoProcurarFloatControl);
            click(campoProcurarFloatControl);
            sendKeys(campoProcurarFloatControl,campoLote);
            waitForInvisibilityOfElementLocated(loadingWait);
            waitForVisibilityOfElementLocated(Lote);
            click(Lote);
            waitForInvisibilityOfElementLocated(loadingWait);
            //End FLoat Control

    //Confirmar
            waitForVisibilityOfElementLocated(Confirmar);
            click(Confirmar);
            waitForInvisibilityOfElementLocated(loadingWait);

    //Quantidade
            waitForVisibilityOfElementLocated(Quantidade);
            sendKeys(Quantidade,campoQuantidade);
            waitForInvisibilityOfElementLocated(loadingWait);

    //Adicionar
            waitForVisibilityOfElementLocated(Adicionar);
            click(Adicionar);
            click(Adicionar);
            waitForInvisibilityOfElementLocated(loadingWait);
    //Salvar
           waitForVisibilityOfElementLocated(Salvar2);
           click(Salvar2);
           waitForInvisibilityOfElementLocated(loadingWait);




    }

    public void editarTransferenciaDeEstoque(String campoProdutoEditado, String campoLoteEditado, String campoQuantidadeEditado){

        //selecionar almoxarifado
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(AlmoxarifadoEditado);
        click(AlmoxarifadoEditado);
        waitForInvisibilityOfElementLocated(loadingWait);

      //Editar
        waitForVisibilityOfElementLocated(Editar);
        click(Editar);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(Salvar);
        click(Salvar);
        waitForInvisibilityOfElementLocated(loadingWait);

      //Aba Produtos

        waitForVisibilityOfElementLocated(AbaProdutos);
        click(AbaProdutos);
        waitForInvisibilityOfElementLocated(loadingWait);


        //Produtos2
        waitForVisibilityOfElementLocated(BtnAdicionar3);
        click(BtnAdicionar3);
        waitForInvisibilityOfElementLocated(loadingWait);

        //Nome do Produto2
        waitForVisibilityOfElementLocated(IconeNome);
        click(IconeNome);
        waitForInvisibilityOfElementLocated(loadingWait);

        //Start Float control
        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        click(campoProcurarFloatControl);
        sendKeys(campoProcurarFloatControl, campoProdutoEditado);
        waitForVisibilityOfElementLocated(ProdutoEditado);
        click(ProdutoEditado);
        waitForInvisibilityOfElementLocated(loadingWait);
        //End search float control

        //Lote
        waitForVisibilityOfElementLocated(selectLote);
        click(selectLote);
        waitForVisibilityOfElementLocated(loteExistente);
        click(loteExistente);
        waitForInvisibilityOfElementLocated(loadingWait);

        waitForVisibilityOfElementLocated(IconeLote);
        click(IconeLote);
        waitForInvisibilityOfElementLocated(loadingWait);


        //Start Float Control
        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        click(campoProcurarFloatControl);
        sendKeys(campoProcurarFloatControl, campoLoteEditado);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(LoteEditado);
        click(LoteEditado);
        waitForInvisibilityOfElementLocated(loadingWait);
        //End FLoat Control

        //Confirmar
        waitForVisibilityOfElementLocated(Confirmar);
        click(Confirmar);
        waitForInvisibilityOfElementLocated(loadingWait);

        //Quantidade
        waitForVisibilityOfElementLocated(Quantidade);
        sendKeys(Quantidade, campoQuantidadeEditado);
        waitForInvisibilityOfElementLocated(loadingWait);

        //Adicionar
        waitForVisibilityOfElementLocated(Adicionar);
        click(Adicionar);
        click(Adicionar);
        waitForInvisibilityOfElementLocated(loadingWait);


       //Salvar
       waitForVisibilityOfElementLocated(Salvar2);
       click(Salvar2);
        waitForInvisibilityOfElementLocated(loadingWait);








    }
    public void excluirTransferenciaDeEstoque(){
        waitForVisibilityOfElementLocated(BtnAlmoxarifadoExcluir);
        click(BtnAlmoxarifadoExcluir);
        waitForInvisibilityOfElementLocated(loadingWait);

        waitForVisibilityOfElementLocated(Excluir);
        click(Excluir);
        waitForInvisibilityOfElementLocated(loadingWait);

        waitForVisibilityOfElementLocated(BtnConfirmar);
        click(BtnConfirmar);
        waitForInvisibilityOfElementLocated(loadingWait);


    }
}
