package com.javaseleniumtemplate.pages;
import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;

public class MainPage extends PageBase {
    //Mapping:
    By menuPrincipal = By.xpath("//*[@data-zh-id='zh-header-menu-button']//*[@type='button']");
    By loadingWait = By.xpath("//*[@class='zh-background-loading ng-scope']//span[@class='zh-loading-icon']");
    By usernameLoginInfoTextArea = By.xpath("//div[@class='zh-header-info']");
    By reportIssueLink = By.xpath("//a[@href='/bug_report_page.php']");


    //ESTOQUE:
    By Estoque = By.xpath("//*[@data-zh-id='90884303627023268473090']//span[text() = 'Estoque']");
    By AjusteIventario = By.xpath("//*[@data-zh-id='9088430366648752383094']//span[text() = 'Ajuste de Inventário']");
    By implantacaoDeEstoque = By.xpath("//*[@data-zh-id='9088430363559080913095']//span[text() = 'Implantação de Estoque']");
    By Relatorios = By.xpath("//*[@data-zh-id='90884303642152590193144']//span[text() = 'Relatórios']");
    By PosicaoDeEstoque = By.xpath("//*[@data-zh-id='90884303631807304033145']//span[text() = 'Posição de Estoque']");
    By MovimentacaoDeEstoque = By.xpath("//*[@data-zh-id='90884303637956338223148']//span[text() = 'Movimentação de Estoque']");
    By EntradaDeEstoque = By.xpath("//*[@data-zh-id='9088430364157211523852']//span[text() = 'Entrada de Estoque']");
    By RetiradaDeEstoque = By.xpath("//span[text()='Retirada de Estoque']");
    By RecalculoDeEstoque = By.xpath("//span[text()='Recálculo de Estoque']");
    By TransferenciaDeEstoque = By.xpath("//span[text()='Transferência de Estoque']");

    //COMPRAS:
    By parametrizacao = By.xpath("//*[@data-zh-id='90884303613158256665325']//span[text() = 'Parametrização']");
    By cadastroGerais = By.xpath("//*[@data-zh-id='9088430361253460955326']//span[text() = 'Cadastros Gerais']");
    By produto = By.xpath("//*[@data-zh-id='90884303630165382671182']//span[text() = 'Produto']");
    By produto2 = By.xpath("//*[@data-zh-id='90884303619003718911183']//span[text() = 'Produto']");


    //Arvore de Prodto
    By ArvoreDeProduto = By.xpath("//span[text()='Árvore de Produto']");


    //Actions
    public String retornaUsernameDasInformacoesDeLogin(){
        return getText(usernameLoginInfoTextArea);
    }
    public void clicarEmReportIssue(){
        click(reportIssueLink);
    }
        public void clicarEmMenuPrincipal(){
            waitForInvisibilityOfElementLocated(loadingWait);
            waitForElement(usernameLoginInfoTextArea);
            waitForVisibilityOfElementLocated(menuPrincipal);
            waitForInvisibilityOfElementLocated(loadingWait);
            waitForVisibilityOfElementLocated(menuPrincipal);
            click(menuPrincipal);
            waitForInvisibilityOfElementLocated(loadingWait);
        }
        public void clicarEmEstoque(){
            waitForVisibilityOfElementLocated(Estoque);
            click(Estoque);
        }

        public void clicarEmParametrizacao(){
        waitForVisibilityOfElementLocated(parametrizacao);
        click(parametrizacao);
    }

    //EST:
        public void clicarEmAjusteDeIventario(){
        waitForVisibilityOfElementLocated(AjusteIventario);
        click(AjusteIventario);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
        public void clicarEmImplantacaoEstoque(){
        waitForVisibilityOfElementLocated(implantacaoDeEstoque);
        click(implantacaoDeEstoque);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
        public void clicarEmPosicaDeEstoque(){
        waitForVisibilityOfElementLocated(Relatorios);
        click(Relatorios);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(PosicaoDeEstoque);
        click(PosicaoDeEstoque);
        waitForInvisibilityOfElementLocated(loadingWait);

        }
        public void clicarEmMovimentacaoDeEstoque(){
            waitForVisibilityOfElementLocated(Relatorios);
            click(Relatorios);
            waitForInvisibilityOfElementLocated(loadingWait);
            waitForVisibilityOfElementLocated(MovimentacaoDeEstoque);
            click(MovimentacaoDeEstoque);
            waitForInvisibilityOfElementLocated(loadingWait);

        }
        public void clicarEmEntradaDeEstoque(){
            waitForVisibilityOfElementLocated(EntradaDeEstoque);
            click(EntradaDeEstoque);
            waitForInvisibilityOfElementLocated(loadingWait);
        }
        public void clicarEmRetiradaDeEstoque(){
        waitForVisibilityOfElementLocated(RetiradaDeEstoque);
        click(RetiradaDeEstoque);
        waitForVisibilityOfElementLocated(RetiradaDeEstoque);
        }
        public void clicarEmRecalculoDeEstoque(){
        waitForVisibilityOfElementLocated(RecalculoDeEstoque);
        click(RecalculoDeEstoque);
        waitForVisibilityOfElementLocated(RecalculoDeEstoque);
        }
        public void clicarEmTransferenciaDeEstoque(){
        waitForVisibilityOfElementLocated(TransferenciaDeEstoque);
        click(TransferenciaDeEstoque);
        waitForVisibilityOfElementLocated(TransferenciaDeEstoque);
        }

    //PARAMETRIZAÇÃO:
        public void clicarEmProduto(){
        waitForVisibilityOfElementLocated(cadastroGerais);
        click(cadastroGerais);
        waitForInvisibilityOfElementLocated(loadingWait);
            waitForVisibilityOfElementLocated(produto);
            click(produto);
            waitForInvisibilityOfElementLocated(loadingWait);
            waitForVisibilityOfElementLocated(produto2);
            click(produto2);
            waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void clicarEmArvoreProduto(){
        waitForVisibilityOfElementLocated(cadastroGerais);
        click(cadastroGerais);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(produto);
        click(produto);
        waitForInvisibilityOfElementLocated(loadingWait);
        click(ArvoreDeProduto);
        waitForVisibilityOfElementLocated(loadingWait);
    }

}
