package com.javaseleniumtemplate.tests.Estoque;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.MainFlows;
import com.javaseleniumtemplate.flows.TransferenciaDeEstoqueFlows;
import com.javaseleniumtemplate.pages.EstoquePages.TransferenciaDeEstoquePage;
import com.javaseleniumtemplate.pages.MainPage;
import org.testng.annotations.Test;

public class TransferenciaDeEstoqueTests extends TestBase {
    MainPage mainPage;
    LoginFlows loginFlows;
    MainFlows mainFlows;
    TransferenciaDeEstoqueFlows transferenciaDeEstoqueFlows;
    TransferenciaDeEstoquePage transferenciaDeEstoquePage;

    @Test(description = "Est-14")

    public void RealizarTransferenciaDeEstoque(){
        //Objects instances
         mainPage = new MainPage();
         loginFlows = new LoginFlows();
         mainFlows = new MainFlows();
         transferenciaDeEstoqueFlows = new TransferenciaDeEstoqueFlows();
         transferenciaDeEstoquePage = new TransferenciaDeEstoquePage();


        //Parameteres_Lançamento
        String descUnidade = "HELA INGREDIENTES BRASIL";
        String almoxarifadoOrigem = "HELA MATRIZ";
        String almoxaridfadoDestino = "HELA LOJA";
        String campoProduto = "Hela Poultry Broth Paste Clear KG";
        String campoLote = "00231100";
        String campoQuantidade = "1";




        //Rotine:
        loginFlows.efetuarLogin();
        mainFlows.AcessandoTransferenciaDeEstoque();
        transferenciaDeEstoqueFlows.preencherFiltroTransferenciaDeEstoque(descUnidade, almoxarifadoOrigem,almoxaridfadoDestino);
        transferenciaDeEstoqueFlows.realizarTransferenciaDeEstoque(campoProduto,campoLote, campoQuantidade);


    }


    @Test(description = "Est-15")
    public void EditarTransferenciaDeEstoque(){
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        transferenciaDeEstoqueFlows = new TransferenciaDeEstoqueFlows();
        transferenciaDeEstoquePage = new TransferenciaDeEstoquePage();


        //Parameteres_Login


        //Parameteres_Lançamento
        String descUnidade = "HELA INGREDIENTES BRASIL";
        String almoxarifadoOrigem = "HELA MATRIZ";
        String almoxarifadoDestino = "HELA LOJA";
        String campoProduto2 = "Hela Poultry Broth Paste Clear KG";
        String campoLoteEditado = "EST-231100";
        String campoQuantidadeEditado = "1";
        String campoProdutoEditado = "Geflugelbruhe Paste (Hela 7562510050001)";

        //Rotine
        loginFlows.efetuarLogin();
        mainFlows.AcessandoTransferenciaDeEstoque();
        transferenciaDeEstoqueFlows.preencherFiltroTransferenciaDeEstoque(descUnidade,almoxarifadoOrigem,almoxarifadoDestino);
        transferenciaDeEstoqueFlows.editarTransferenciaDeEstoque(campoProdutoEditado,campoLoteEditado, campoQuantidadeEditado);


    }

    @Test(description = "Est-16")
    public void ExcluirTransferenciaDeEstoque(){
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        transferenciaDeEstoqueFlows = new TransferenciaDeEstoqueFlows();
        transferenciaDeEstoquePage = new TransferenciaDeEstoquePage();



        //Parameteres_Lançamento
        String descUnidade = "HELA INGREDIENTES BRASIL";
        String almoxarifadoOrigem = "HELA MATRIZ";
        String almoxaridfadoDestino = "HELA LOJA";
        String campoProduto = "Hela Poultry Broth Paste Clear KG";


        //Rotine:
        loginFlows.efetuarLogin();
        mainFlows.AcessandoTransferenciaDeEstoque();
        transferenciaDeEstoqueFlows.preencherFiltroTransferenciaDeEstoque(descUnidade,almoxarifadoOrigem,almoxaridfadoDestino);
        transferenciaDeEstoqueFlows.excluirTransferenciaDeEstoque();

    }

}
